/**
 * This code was AUTOGENERATED using the kinobi library.
 * Please DO NOT EDIT THIS FILE, instead use visitors
 * to add features, then rerun kinobi to update it.
 *
 * @see https://github.com/metaplex-foundation/kinobi
 */

import {
  Account,
  EncodedAccount,
  FetchAccountConfig,
  FetchAccountsConfig,
  assertAccountExists,
  decodeAccount,
  fetchEncodedAccount,
  fetchEncodedAccounts,
} from '@solana/accounts';
import { Address } from '@solana/addresses';
import {
  Codec,
  Decoder,
  Encoder,
  combineCodec,
  mapEncoder,
} from '@solana/codecs-core';
import {
  getArrayDecoder,
  getArrayEncoder,
  getStructDecoder,
  getStructEncoder,
} from '@solana/codecs-data-structures';
import { getU8Decoder, getU8Encoder } from '@solana/codecs-numbers';
import { TmKey, TmKeyArgs, getTmKeyDecoder, getTmKeyEncoder } from '../types';

export type EditionMarker<TAddress extends string = string> = Account<
  EditionMarkerAccountData,
  TAddress
>;

export type EditionMarkerAccountData = { key: TmKey; ledger: Array<number> };

export type EditionMarkerAccountDataArgs = { ledger: Array<number> };

export function getEditionMarkerAccountDataEncoder() {
  return mapEncoder(
    getStructEncoder<{ key: TmKeyArgs; ledger: Array<number> }>([
      ['key', getTmKeyEncoder()],
      ['ledger', getArrayEncoder(getU8Encoder(), { size: 200 })],
    ]),
    (value) => ({ ...value, key: TmKey.EditionMarker })
  ) satisfies Encoder<EditionMarkerAccountDataArgs>;
}

export function getEditionMarkerAccountDataDecoder() {
  return getStructDecoder<EditionMarkerAccountData>([
    ['key', getTmKeyDecoder()],
    ['ledger', getArrayDecoder(getU8Decoder(), { size: 200 })],
  ]) satisfies Decoder<EditionMarkerAccountData>;
}

export function getEditionMarkerAccountDataCodec(): Codec<
  EditionMarkerAccountDataArgs,
  EditionMarkerAccountData
> {
  return combineCodec(
    getEditionMarkerAccountDataEncoder(),
    getEditionMarkerAccountDataDecoder()
  );
}

export function decodeEditionMarker<TAddress extends string = string>(
  encodedAccount: EncodedAccount<TAddress>
): EditionMarker<TAddress> {
  return decodeAccount(encodedAccount, getEditionMarkerAccountDataDecoder());
}

export async function fetchEditionMarker<TAddress extends string = string>(
  rpc: Parameters<typeof fetchEncodedAccount>[0],
  address: Address<TAddress>,
  config?: FetchAccountConfig
): Promise<EditionMarker<TAddress>> {
  const maybeAccount = await fetchEncodedAccount(rpc, address, config);
  assertAccountExists(maybeAccount);
  return decodeEditionMarker(maybeAccount);
}

export async function safeFetchEditionMarker<TAddress extends string = string>(
  rpc: Parameters<typeof fetchEncodedAccount>[0],
  address: Address<TAddress>,
  config?: FetchAccountConfig
): Promise<EditionMarker<TAddress> | null> {
  const maybeAccount = await fetchEncodedAccount(rpc, address, config);
  return maybeAccount.exists ? decodeEditionMarker(maybeAccount) : null;
}

export async function fetchAllEditionMarker(
  rpc: Parameters<typeof fetchEncodedAccounts>[0],
  addresses: Array<Address>,
  config?: FetchAccountsConfig
): Promise<EditionMarker[]> {
  const maybeAccounts = await fetchEncodedAccounts(rpc, addresses, config);
  return maybeAccounts.map((maybeAccount) => {
    assertAccountExists(maybeAccount);
    return decodeEditionMarker(maybeAccount);
  });
}

export async function safeFetchAllEditionMarker(
  rpc: Parameters<typeof fetchEncodedAccounts>[0],
  addresses: Array<Address>,
  config?: FetchAccountsConfig
): Promise<EditionMarker[]> {
  const maybeAccounts = await fetchEncodedAccounts(rpc, addresses, config);
  return maybeAccounts
    .filter((maybeAccount) => maybeAccount.exists)
    .map((maybeAccount) => decodeEditionMarker(maybeAccount as EncodedAccount));
}

export function getEditionMarkerSize(): number {
  return 201;
}
